//
// https://www.ramecera.it/myscrewdriver.html
// e-mail: screwdriver@ramecera.it
//
/* This program and the accompanying materials are made available under
 * the terms of the Eclipse Public License v1.0 which accompanies this
 * distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html */
package it.ramecera.salad.everyday;

import java.util.Properties;

/**
 * <p>
 * Treatment of property data. This data is conventionally called <b>
 * candy</b>.
 * </p>
 * <p>
 * Creation date: 2020-04-09<br>
 * modification date: 2020-04-09<br>
 * Company: Ramecera™
 * </p>
 * <p>
 * Modifications:<br>
 * </p>
 * 
 * @author M. Maglioni */
public interface Candies {

	/** ordinary properties */
	public Properties properties = new Properties();

	/** peculiar character */
	public static final char H92 = 92; // backslash
	/** peculiar character */
	public static final char H47 = 47; // slash;
	/** peculiar character */
	public static final String SLASH = String.valueOf(H47);
	/** peculiar character */
	public static final char PARENTESI_APERTA = 40;
	/** peculiar character */
	public static final char PARENTESI_CHIUSA = 41;
	/** peculiar character */
	public static final char LINE_FEED = 10;
	/** peculiar character */
	public final static char H13 = 13;
	/** peculiar character */
	public final static char H171 = 171;
	/** peculiar character */
	public final static char H160 = 160;
	/** peculiar character */
	public final static char H187 = 187;
	/** peculiar character */
	public final static char EQUALITY_SIGN = 61;
	/** peculiar character */
	public final static String SPACE = " ";
	/** peculiar character */
	public final static String NON_BREAKING = String.valueOf(H160);
	/** peculiar character */
	public final static String CAAP = String.valueOf(H171);
	/** peculiar character */
	public final static String CACH = String.valueOf(H187);
	/** peculiar character */
	public final static String CR = String.valueOf(H13);
	/** peculiar character */
	public static final String LF = String.valueOf(LINE_FEED);
	/** peculiar character */
	public static final char TAB = 9;
	/** peculiar character */
	public static final String TABS = String.valueOf(TAB);
	/** peculiar character */
	public String UNDERSCORE = "_";
	/** peculiar character */
	public String COMMA = ",";
	/** peculiar character */
	public String COLON = ":";
	/** particular codes, operations of a file corrections */
	public int SURGERY1 = 1;
	/** particular signs */
	public static final String SEGNO_A = "çvç";
	/** particular signs */
	public static final String[] CRUD = { "C", "R", "U", "D" };
	/** Roman numerals from 1 to 50 */
	public static final String[] ROMANI = { "", "I", "II", "III", "IV",
			"V", "VI", "VII", "VIII", "IX", "X", "XI", "XII", "XIII",
			"XIV", "XV", "XVI", "XVII", "XVIII", "IXX", "XX", "XXI",
			"XXII", "XXIII", "XXIV", "XXV", "XXVI", "XXVII", "XXVIII",
			"IXXX", "XXX", "XXXI", "XXXII", "XXXIII", "XXXIV", "XXXV",
			"XXXVI", "XXXVII", "XXXVIII", "XXXIX", "XXXX", "XXXXI",
			"XXXXII", "XXXXIII", "XXXXIV", "XXXXV", "XXXXVI", "XXXXVII",
			"XXXXVIII", "IL", "L" };

	/**
	 * <p>
	 * Reads the properties file and returns it on the same object t.
	 * </p>
	 * <p>
	 * Creation date: 2020-04-09<br>
	 * Last updated: 2020-04-09
	 * </p>
	 * <p>
	 * Changes:<br>
	 * </p>
	 * 
	 * @param p name of the properties file
	 * @throws ExactException objecting if the data contained in the
	 *         properties file is incorrect */
	public abstract void readProperties(String p)

			throws ExactException;

}
