//
// https://www.ramecera.it/myscrewdriver.html
// e-mail: screwdriver@ramecera.it
//
/* This program and the accompanying materials are made available under
 * the terms of the Eclipse Public License v1.0 which accompanies this
 * distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html */
package it.ramecera.screwdriver.component;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.HashMap;
import java.util.List;

import it.ramecera.salad.everyday.Candies;
import it.ramecera.salad.everyday.ExactException;
import it.ramecera.screwdriver.CandyScrew;
import it.ramecera.screwdriver.Cst;
import it.ramecera.screwdriver.Markup;
import it.ramecera.screwdriver.Skill;
import it.ramecera.screwdriver.Train;
import it.ramecera.screwdriver.outfits.TableOutfit;

/** @author M. Maglioni */
final public class InterfaceTabellaService_java extends FileComponent {

	/** @param skill application base values
	 * @param snippetG path and snippet file name (fragment)
	 * @param candies external application properties */
	public InterfaceTabellaService_java(Skill skill, String snippetG,
			CandyScrew candies) {
		super();
		this.skill = skill;
		this.snippetG = snippetG;
		this.candies = candies;
	}

	/** @throws ExactException exception specified by a numeric code */
	@Override
	public void synthesis(HashMap<String, Markup> markupE,
			List<Train> trainE, CandyScrew candyScrew)

			throws FileNotFoundException, IOException, ExactException {

		TableOutfit ct = skill.tableDBE.get(skill.tK);
		producedMaterial += "package " + skill.pckg + "."
				+ ct.railLowercase + ".service;" + Candies.LF
				+ Candies.LF;
		producedMaterial += "import " + ct.pathDots + "."
				+ ct.entityName + ";" + Candies.LF + Candies.LF;
		producedMaterial += "public interface I" + ct.railUppercase
				+ ct.entityName + "Service {" + Candies.LF + Candies.LF;
		producedMaterial += Candies.TABS + "/* " + Cst.KNIFE + " */"
				+ Candies.LF;
		producedMaterial += "}";
	}

	/* written only to comply with the abstract class FileComponent */
	@SuppressWarnings("javadoc")
	@Override
	/** @param markupE the list of markups
	 * @param skill together with the characteristics of the application
	 * @param trash file where the deleted files are moved
	 * @throws ExactException exception specified by a numeric code */
	public void directory(HashMap<String, Markup> markupE)

			throws ExactException {

	}
}
